package org.jvcode.osgi.client;

import org.apache.felix.framework.Felix;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.Constants;

import java.util.HashMap;
import java.util.Map;

/**
 * Demonstration client for OSGi example
 *
 * @author Jochen Vajda
 */
public class HelloWorldClient
{
    public static void main(String[] args)
    {
        try
        {
            // Initialize Apache Felix Framework
            Map<String, String> configMap = new HashMap<String, String>();
            configMap.put(Constants.FRAMEWORK_STORAGE_CLEAN, "onFirstInit");
            Felix framework = new Felix(configMap);
            framework.init();

            // Load bundles
            BundleContext context = framework.getBundleContext();
            Bundle provider = context.installBundle("file:out/production/HelloWorldProvider.jar");
            Bundle consumer = context.installBundle("file:out/production/HelloWorldConsumer.jar");

            // Start and stop framework and bundles
            framework.start();
            provider.start();
            consumer.start();
            framework.stop();
        }
        catch (Exception exception)
        {
            System.err.println("Error while executing program: " + exception);
            exception.printStackTrace();
            System.exit(0);
        }
    }
}
