package org.jvcode.osgi.provider;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

/**
 * Activator for the HelloWorldProvider bundle.
 * Registers the HelloWorldService as OSGi service.
 *
 * @author Jochen Vajda
 */
public class Activator implements BundleActivator
{
    public void start(BundleContext bundleContext) throws Exception
    {
        System.out.println("HelloWorldProvider is being started...");
        System.out.println("Registering HelloWorldService...");
        bundleContext.registerService(HelloWorldService.class.getName(), new HelloWorldProvider(), null);
    }

    public void stop(BundleContext bundleContext) throws Exception
    {
        System.out.println("HelloWorldProvider is being stopped...");
    }
}
